#include <stdint.h>
#include <string.h>

static inline int32_t	f2i32(float f)
{
	int32_t	int32;

	memcpy(&int32, &f, sizeof(int32));
	return int32;
}

static inline int	is_minus(uint32_t f)
{
	return (f & 0x80000000);
}

static inline int	exponent(uint32_t f)
{
	return ((f >> 23) & 0xff) - 127;
}

static inline uint32_t	fraction(uint32_t f)
{
	return ((f & 0x7fffff) | 0x800000);
}

static inline void	strong_limitbits(float *pf, int bits)
{
	uint32_t * const	p_u32 = (uint32_t *)pf;

	if (exponent(*p_u32) < 0) {
		bits += exponent(*p_u32);
	}
	if (bits >= 25) {
		return;		// do nothing
	} else if (bits < 2) {
		bits = 2;
	}
	*p_u32 &= (0xffffffff << (25 - bits));
}
